"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var struct_1 = require("muschema/struct");
var uint32_1 = require("muschema/uint32");
var string_1 = require("muschema/string");
function unfoldRPCProtocolSchema(schema) {
    var result = [
        { client: {}, server: {} },
        { client: {}, server: {} },
    ];
    var CallbackIDSchema = new uint32_1.MuUint32();
    Object.keys(schema.client).forEach(function (method) {
        result[0].client[method] = new struct_1.MuStruct({
            base: schema.client[method][0],
            id: CallbackIDSchema,
        });
        result[1].server[method] = new struct_1.MuStruct({
            base: schema.client[method][1],
            id: CallbackIDSchema,
        });
    });
    Object.keys(schema.server).forEach(function (method) {
        result[0].server[method] = new struct_1.MuStruct({
            base: schema.server[method][0],
            id: CallbackIDSchema,
        });
        result[1].client[method] = new struct_1.MuStruct({
            base: schema.server[method][1],
            id: CallbackIDSchema,
        });
    });
    return result;
}
exports.unfoldRPCProtocolSchema = unfoldRPCProtocolSchema;
function MuRPC(arg, response) {
    return [arg, response];
}
exports.MuRPC = MuRPC;
exports.MuRPCErrorSchema = new struct_1.MuStruct({
    message: new string_1.MuString(),
    id: new uint32_1.MuUint32(),
});
exports.MuRPCErrorProtocolSchema = {
    client: {
        error: exports.MuRPCErrorSchema,
    },
    server: {
        error: exports.MuRPCErrorSchema,
    },
};
//# sourceMappingURL=rpc.js.map